<?php defined('SYSPATH') or die('No direct script access.');

class Model_Grades extends Model
{
    public static function factory() {
        return new self();
    }

    public function getGrades() {
        $sql = "CALL `GetGrades`();";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function common() {
        $GradeList = $this->GetGrades();
        $Grade = array();
        $i = 0;

        foreach ($GradeList as $row) {
            $i++;
            $Grade[$i]['ID'] = $row['ID'];
            $Grade[$i]['Num'] = $row['Num'];
            $Grade[$i]['Degree'] = $row['Degree'];
            if ($row['Degree'] == 'bachelor' || $row['Degree'] == 'specialist') $Grade[$i]['Title'] = 'Курс ' . $row['Num'];
            if ($row['Degree'] == 'master') $Grade[$i]['Title'] = 'Магистратура ' . $row['Num'];
        }

        return new DataArray_Result($Grade);
    }

    public function structured() {
        $grades = $this->common()->asArray();
        $gradesHandled = array();
        $i = $j = 0;
        $degree = 'null';
        $degrees = array('bachelor' => 'Бакалавриат', 'specialist' => 'Специалитет', 'master' => 'Магистратура');
        foreach ($grades as $row) {
            if ($degree != $row['Degree']) {
                $degree = $row['Degree'];
                $i++;
                $j = 0;
            }
            $j++;
            $gradesHandled[$i]['Title'] = $degrees[$row['Degree']];
            $gradesHandled[$i]['Grades'][$j]['ID'] = $row['ID'];
            $gradesHandled[$i]['Grades'][$j]['Num'] = $row['Num'];
        }
        return new DataArray_Result($gradesHandled);
    }
}
